;; Arithmetic Expression data type
(define-type AE
  [num (n number?)]
  [add (l AE?)
       (r AE?)]
  [sub (l AE?)
       (r AE?)]
  [mul (l AE?)
       (r AE?)]
  [pow (l AE?)
       (r AE?)])

;; parse : sexp -> AE
(define (parse sexp)
  (cond
    [(number? sexp) (num sexp)]
    [(list? sexp)
     (case (first sexp)
       [(+) (add (parse(second sexp))
                 (parse(third sexp)))]
       [(-) (sub (parse(second sexp))
                 (parse(third sexp)))]
       [(*) (mul (parse(second sexp))
                 (parse(third sexp)))]
       [(^) (pow (parse(second sexp))
                 (parse(third sexp)))]
       )]
    ))

;; calc :: AE -> Num
(define (calc sexp)
  (type-case AE sexp
             [num (n) n] 
             [add (l r) (+ (calc l) (calc r))] 
             [sub (l r) (- (calc l) (calc r))]
             [mul (l r) (* (calc l) (calc r))] 
             [pow (l r) (power (calc l) (calc r))] 
             ))

;; power :: Num -> Num -> Num
(define (power a b)
  (if (= b 0) 1
      (* a (power a (- b 1)))))


;(calc (parse '(+ 1 2)))

(define (calculadora exp) 
  (calc (parse exp)))

(define (REPL)
  (calculadora (read)) (REPL))

(REPL)